BEGIN;
CREATE TABLE meta_browseversion (version VARCHAR(32));
INSERT INTO meta_browseversion VALUES ('1.08');

CREATE TABLE meta_relations (
	pk		bigserial	PRIMARY KEY,
	name	varchar(32) NOT NULL,
	version	integer		NOT NULL,
	is_aggr_enabled boolean default true,
    tags	varchar(1024),

	UNIQUE (name, version)
);

CREATE TABLE meta_fields (
	fk			bigint		NOT NULL REFERENCES meta_relations ON DELETE CASCADE,
	pos			integer		NOT NULL,
	name		varchar(32)	NOT NULL,
	type		varchar(32)	NOT NULL,
	is_dict		boolean		NOT NULL,
	is_indexed	boolean		NOT NULL,
	is_security	boolean		NOT NULL DEFAULT false,

	PRIMARY KEY	(fk, pos),
	UNIQUE (fk, name)
);

CREATE TABLE meta_views (
    uuid            VARCHAR(36)     PRIMARY KEY,
    relation        BIGINT          NOT NULL REFERENCES meta_relations ON DELETE CASCADE,
    groupingfields  VARCHAR(1024)   NOT NULL,
    indexedfields  VARCHAR(1024),
    agntype         CHAR(3)         NOT NULL DEFAULT 'CNT',
    agnfield        VARCHAR(32),
    condition       TEXT,
    ordered         INTEGER,
    mattype         CHAR(4)         NOT NULL DEFAULT 'NONE',
    name			VARCHAR(128)
);

CREATE TABLE meta_lastmods (
    name            VARCHAR(64)     PRIMARY KEY,
    stamp           TIMESTAMP WITH TIME ZONE,
    rebuild			BOOLEAN NOT NULL DEFAULT FALSE,
    tick			BIGINT NOT NULL
);

CREATE TABLE meta_ticks (
    tick			BIGINT NOT NULL
);
INSERT INTO meta_ticks (tick) VALUES (1);

COMMIT;
