CREATE TABLE OBJECT_METADATA (
	_ID		INTEGER			PRIMARY KEY,
	_HISTORY	BOOLEAN			NOT NULL	DEFAULT FALSE,
	ID		CHARACTER VARYING(512)	NOT NULL,
	BRANCH		CHARACTER VARYING(256)	NOT NULL,
	VERSION		CHARACTER VARYING(256)	NOT NULL,
	STATUS		CHARACTER VARYING(32)	NOT NULL,
	TIMESTAMP	TIMESTAMP		NOT NULL,
	ALT_ID		CHARACTER VARYING(512),
	ALT_BRANCH	CHARACTER VARYING(256),
	ALT_VERSION	CHARACTER VARYING(256),

	UNIQUE (ID, BRANCH, VERSION)
);

CREATE INDEX OBJECT_METADATA_TIMESTAMP_INDEX ON OBJECT_METADATA (TIMESTAMP);

CREATE TABLE OBJECT_PARTS (
	_META_ID	BIGINT			NOT NULL	REFERENCES OBJECT_METADATA (_ID),
	PARTSTAMP	TIMESTAMP		NOT NULL,
	TYPE		CHARACTER VARYING(256)	NOT NULL,
	DATA		TEXT			NOT NULL,

	PRIMARY KEY (_META_ID, TYPE)
);

CREATE INDEX OBJECT_PARTS_TIMESTAMP_INDEX ON OBJECT_PARTS (PARTSTAMP);

CREATE TABLE METADATA_TAGS (
	TAG		TEXT	NOT NULL,
	_META_ID	BIGINT	NOT NULL	REFERENCES	OBJECT_METADATA (_ID),

	UNIQUE (TAG, _META_ID)
);

CREATE INDEX METADATA_TAGS__META_ID ON METADATA_TAGS (_META_ID);
