#!/bin/sh -e

echo "downloading content from $1"

for line in `cut -d' ' -f1- --output-delimiter="|" $1`;do
    from=`echo $line | cut -d'|' -f1`
    to=`echo $line | cut -d'|' -f2`
    [ -n "$CONTENT_CACHE_DIR" ] && cached="$CONTENT_CACHE_DIR/$(basename $to)"
    if [ -n "$cached" ] && [ -f "$cached" ]; then
     cp "$cached" "$to"
     echo "INFO: using cached $to (not downloading from $from)"
    elif wget -4 --timeout=10 --tries=2 -q -O $to $from; then
     echo "INFO: downloaded $from to $to"
     [ -n "$cached" ] && cp "$to" "$cached"
    else
     echo "ERROR: failed download of $from to $to"
    fi
done
