#!/bin/sh
db2dir=${DB2DIR:-lib}
db2driver=${DB2DRIVER:-$db2dir/db2jcc.jar}
db2license=${DB2LICENSE:-$db2dir/db2jcc_license_cu.jar}

if [ ! -f "$db2driver" ] || [ ! -f "$db2license" ]; then
  echo "ERROR: The db2 driver and license jars are not provided in the package" >&2
  echo "ERROR: they need to be placed in \$DB2DIR (default lib)" >&2
  exit 1
fi

exec java -Xmx1024m ${JAVA_OPTS} -XX:+HeapDumpOnOutOfMemoryError -cp "lib/yadda-cli-1.6.2-SNAPSHOT.jar:${db2driver}:${db2license}"  pl.edu.icm.yadda.imports.psjc.PSJCPackCreator "$@"
